function [y, check, what] = Increasing_conservatism( i, pop, d, t)
% INCREASING_CONSERVATISM implements random copying, but the probability to copy 
% decrease linearly with time
%
% Parameters:
% 
% i = index of the observer
% pop = the population
% d = proportion of population for which probability to copy
% decreases
% t = time step

    dem = randi( length( pop ), 1, 1 );
    what = pop( dem );
    if( rand < d )
        if( rand < (100-t)/100 )
            y = what;
            check = 1; 
        else
            y = pop( i );
            check = 0;
        end
    else
        y = what;
        check = 1;
    end
end

    
        
        