
N = 100; 
% population size

repetitions = 1000;
% number of time the simulation is repeated

max_T = 100; 
% maximum number of time steps (a repetition is stopped when the population is
% homogeneous)

out = zeros( N*max_T*repetitions, 3 );
count = 1;
% out: Save the data used to calculate the probability to copy VS frequency)

for r = 1 : repetitions
    % % -----------------------------------------------------------------------
    % % PARAMETERS OF VARIOUS CONDITIONS:
    % % function *Boyd_Richerson_original*
    D = 1;
    % % function *Rule_of_3s*
    % s = 3;
    % % function *Copiers_subgroup*
    % Cp = 50;
    % cop = randperm( N, Cp );
    % % function *Demonstrators_subgroup*
    % Dm= 10;
    % dem = randperm( N, Dm );
    % % function *Copy_or_not*
    % pC = .5;
    % % function *Family_bias*
    % S = 4;
    % pop_res = reshape( 1:N, [], S );
    % % function *Information_retention*
    % m = 3;
    % store_pop = zeros( N, max_T );
    % % function *Variant_preference*
    % pLess = 0.2; 
    % preferred_variant = rand()<.5;
    % % function *Increasing_conservatism*
    % d = .1;
    % -----------------------------------------------------------------------
    %
    % ACTUAL REPETITION STARTS HERE
    % -----------------------------------------------------------------------
    pop =  round( rand( N, 1 ) ); 
    % individuals are randomly initialised with one of the two cultural traits: "0"/"1"
    freq = sum( pop ) / N;
    for t = 1 : max_T
        for i = 1 : N 
            % -------------------------------------------------------------
            % HERE THE CONDITION:
            [pop( i ), check, what] = Boyd_Richerson_original( D, freq );
            % [pop( i ), check, what] = Rule_of_3s( pop, s );
			% [pop( i ), check, what] = Copiers_subgroup( i, pop, cop );
            % [pop( i ), check, what] = Demonstrators_subgroup( pop, dem );
            % [pop( i ), check, what] = Copy_or_not( i, pop, pC );            
            % [pop( i ), check, what] = Family_bias( i, pop, pop_res );
            % [pop( i ), check, what] = Information_retention( store_pop, t, m );
            % the line below is only useful when the condition is *Information_retention*:
            % store_pop( :, t ) = pop;
            % [pop( i ), check, what] = Variant_preference( i, pop, pLess, preferred_variant );
            % [pop( i ), check, what] = Increasing_conservatism( i, pop, d, t );

            % -------------------------------------------------------------
            freq = sum( pop ) / N;
            out( count, : ) = [ check, what, freq ];
            count = count + 1;
        end
        if( ( freq == 0 ) || ( freq == 1 ) )
            break;
        end
    end
end
% PROBABILTY VS FREQUENCY:
copying = zeros( 101, 1 );
count = 1;
for f = 0 : .01 : 1
    temp = out( abs( out(:,3) - f ) < .001, : );
    copying( count ) = sum( ( temp( temp(:,2) == 1, 1 ) ) ) / length( temp );
    count = count + 1;
end



