function [y, check, what] = Copiers_subgroup( i, pop, cop )
% COPIERS_SUBGROUP implements random copying within a fixed number of
% copiers
% 
% Parameters:
%
% i = index of the observer
% pop = the population
% cop = who are the copiers

    what = pop( randi( length( pop ), 1, 1 ) );
    if( find( i == cop ) )
        y = what;
        check = 1;
    else
        y = pop( i );
        check = 0;
    end
end

    
        
        