function [y, check, what] = Family_bias( i, pop, pop_res )
% FAMILY_BIAS implements random copying within subgroups of the population
% 
% Parameters:
%
% i = the index of the observer
% pop = the population
% pop_res = the popualtion indexes divided by subgroups

    [~,fam] = find( pop_res == i );
    demonstrator = randi( length( pop_res( :,fam ) )-1, 1, 1 ) + min( pop_res( :, fam ) );
    y = pop( demonstrator );
    what = y;
    check = 1;
    
end

    
        
        