function [y, check, what] = Rule_of_3s( pop, s )
% RULE_OF_3S this implementation endows individuals with the capacity 
% to sample a subset of random individuals from the population and 
% choose the most common variant among them
% 
% Parameters:
%
% pop = the population
% s = sampe size (remember it can not be higher than half
% of the population, and it must be odd to make sense)

    start_demonstrator = randi( length( pop ) / 2 , 1, 1 );
    y = sum( pop( start_demonstrator:( start_demonstrator + s - 1 ) ) ) >= ceil( s / 2 ); 
    check = 1;
    what = y;
end
